scripts/trylink: remove $CPPFLAGS
[oweals/busybox.git] / scripts / trylink
1 #!/bin/sh
2
3 debug=false
4
5 # Linker flags used:
6 #
7 # Informational:
8 # --warn-common
9 # -Map $EXE.map
10 # --verbose
11 #
12 # Optimizations:
13 # --sort-common                 reduces padding
14 # --sort-section alignment      reduces padding
15 # --gc-sections                 throws out unused sections,
16 #                               does not work for shared libs
17 # -On                           Not used, maybe useful?
18 #
19 # List of files to link:
20 # $l_list                       == --start-group -llib1 -llib2 --end-group
21 # --start-group $O_FILES $A_FILES --end-group
22 #
23 # Shared library link:
24 # -shared                       self-explanatory
25 # -fPIC                         position-independent code
26 # --enable-new-dtags            ?
27 # -z,combreloc                  ?
28 # -soname="libbusybox.so.$BB_VER"
29 # --undefined=lbb_main          Seed name to start pulling from
30 #                               (otherwise we'll need --whole-archive)
31 # -static                       Not used, but may be useful! manpage:
32 #                               "... This option can be used with -shared.
33 #                               Doing so means that a shared library
34 #                               is being created but that all of the library's
35 #                               external references must be resolved by pulling
36 #                               in entries from static libraries."
37
38
39 try() {
40     printf "%s\n" "Output of:" >$EXE.out
41     printf "%s\n" "$*" >>$EXE.out
42     printf "%s\n" "==========" >>$EXE.out
43     $debug && echo "Trying: $*"
44     $@ >>$EXE.out 2>&1
45     return $?
46 }
47
48 check_cc() {
49     local tempname="$(mktemp)"
50     local r
51     echo "int main(int argc,char**argv){return argv?argc:0;}" >"$tempname".c
52     # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
53     # Was using "-xc /dev/null", but we need a valid C program.
54     # "eval" may be needed is CFLAGS can contain
55     # '... -D"BB_VER=KBUILD_STR(1.N.M)" ...'
56     # and we need shell to process quotes!
57     $CC $CFLAGS $1 "$tempname".c -o "$tempname" >/dev/null 2>&1
58     r=$?
59     rm -f "$tempname" "$tempname".c "$tempname".o
60     return $r
61 }
62
63 check_libc_is_glibc() {
64     local tempname="$(mktemp)"
65     local r
66     echo "\
67         #include <stdlib.h>
68         /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
69         #if defined(__GLIBC__) && !defined(__UCLIBC__)
70         syntax error here
71         #endif
72         " >"$tempname".c
73     ! $CC $CFLAGS "$tempname".c -c -o "$tempname".o >/dev/null 2>&1
74     r=$?
75     rm -f "$tempname" "$tempname".c "$tempname".o
76     return $r
77 }
78
79 EXE="$1"
80 CC="$2"
81 CFLAGS="$3"
82 LDFLAGS="$4"
83 O_FILES="$5"
84 A_FILES="$6"
85 LDLIBS="$7"
86
87 # The --sort-section option is not supported by older versions of ld
88 SORT_SECTION="-Wl,--sort-section,alignment"
89 if ! check_cc "-Wl,--sort-section,alignment"; then
90     echo "Your linker does not support --sort-section,alignment"
91     SORT_SECTION=""
92 fi
93
94 START_GROUP="-Wl,--start-group"
95 END_GROUP="-Wl,--end-group"
96 INFO_OPTS="-Wl,--warn-common -Wl,-Map,$EXE.map -Wl,--verbose"
97
98 # gold may not support --sort-common (yet)
99 SORT_COMMON="-Wl,--sort-common"
100 if ! check_cc "-Wl,--sort-common"; then
101     echo "Your linker does not support --sort-common"
102     SORT_COMMON=""
103 fi
104
105 # Static linking against glibc produces buggy executables
106 # (glibc does not cope well with ld --gc-sections).
107 # See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
108 # Note that glibc is unsuitable for static linking anyway.
109 # We are removing -Wl,--gc-sections from link command line.
110 GC_SECTIONS="-Wl,--gc-sections"
111 if (. ./.config && test x"$CONFIG_STATIC" = x"y") then
112     if check_libc_is_glibc; then
113         echo "Static linking against glibc, can't use --gc-sections"
114         GC_SECTIONS=""
115     fi
116 fi
117 # The --gc-sections option is not supported by older versions of ld
118 if test -n "$GC_SECTIONS"; then
119     if ! check_cc "$GC_SECTIONS"; then
120         echo "Your linker does not support $GC_SECTIONS"
121         GC_SECTIONS=""
122     fi
123 fi
124
125 # Sanitize lib list (dups, extra spaces etc)
126 LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
127
128 # First link with all libs. If it fails, bail out
129 echo "Trying libraries: $LDLIBS"
130 # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
131 l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
132 test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
133 try $CC $CFLAGS $LDFLAGS \
134         -o $EXE \
135         $SORT_COMMON \
136         $SORT_SECTION \
137         $GC_SECTIONS \
138         $START_GROUP $O_FILES $A_FILES $END_GROUP \
139         $l_list \
140 || {
141     echo "Failed: $l_list"
142     cat $EXE.out
143     exit 1
144 }
145
146 # Now try to remove each lib and build without it.
147 # Stop when no lib can be removed.
148 while test "$LDLIBS"; do
149     $debug && echo "Trying libraries: $LDLIBS"
150     all_needed=true
151     last_needed=false
152     for one in $LDLIBS; do
153         without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
154         # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
155         l_list=`echo " $without_one " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
156         test x"$l_list" != x"" && l_list="$START_GROUP $l_list $END_GROUP"
157         $debug && echo "Trying -l options: '$l_list'"
158         try $CC $CFLAGS $LDFLAGS \
159                 -o $EXE \
160                 $SORT_COMMON \
161                 $SORT_SECTION \
162                 $GC_SECTIONS \
163                 $START_GROUP $O_FILES $A_FILES $END_GROUP \
164                 $l_list
165         if test $? = 0; then
166             echo " Library $one is not needed, excluding it"
167             LDLIBS="$without_one"
168             all_needed=false
169             last_needed=false
170         else
171             echo " Library $one is needed, can't exclude it (yet)"
172             last_needed=true
173         fi
174     done
175     # All libs were needed, can't remove any
176     $all_needed && break
177     # Optimization: was the last tried lib needed?
178     if $last_needed; then
179         # Was it the only one lib left? Don't test again then.
180         { echo "$LDLIBS" | grep -q ' '; } || break
181     fi
182 done
183
184 # Make the binary with final, minimal list of libs
185 echo "Final link with: ${LDLIBS:-<none>}"
186 l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
187 test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
188 # --verbose gives us gobs of info to stdout (e.g. linker script used)
189 if ! test -f busybox_ldscript; then
190     try $CC $CFLAGS $LDFLAGS \
191             -o $EXE \
192             $SORT_COMMON \
193             $SORT_SECTION \
194             $GC_SECTIONS \
195             $START_GROUP $O_FILES $A_FILES $END_GROUP \
196             $l_list \
197             $INFO_OPTS \
198     || {
199         cat $EXE.out
200         exit 1
201     }
202 else
203     echo "Custom linker script 'busybox_ldscript' found, using it"
204     # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
205     #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
206     #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
207     #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
208     # This will eliminate most of the padding (~3kb).
209     # Hmm, "ld --sort-section alignment" should do it too.
210     try $CC $CFLAGS $LDFLAGS \
211             -o $EXE \
212             $SORT_COMMON \
213             $SORT_SECTION \
214             $GC_SECTIONS \
215             -Wl,-T,busybox_ldscript \
216             $START_GROUP $O_FILES $A_FILES $END_GROUP \
217             $l_list \
218             $INFO_OPTS \
219     || {
220         cat $EXE.out
221         exit 1
222     }
223 fi
224
225 . ./.config
226
227 sharedlib_dir="0_lib"
228
229 if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
230     mkdir "$sharedlib_dir" 2>/dev/null
231     test -d "$sharedlib_dir" || {
232         echo "Cannot make directory $sharedlib_dir"
233         exit 1
234     }
235     ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
236
237     EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
238     try $CC $CFLAGS $LDFLAGS \
239             -o $EXE \
240             -shared -fPIC \
241             -Wl,--enable-new-dtags \
242             -Wl,-z,combreloc \
243             -Wl,-soname="libbusybox.so.$BB_VER" \
244             -Wl,--undefined=lbb_main \
245             $SORT_COMMON \
246             $SORT_SECTION \
247             $START_GROUP $A_FILES $END_GROUP \
248             $l_list \
249             $INFO_OPTS \
250     || {
251         echo "Linking $EXE failed"
252         cat $EXE.out
253         exit 1
254     }
255     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
256     chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
257     echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
258 fi
259
260 if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
261     EXE="$sharedlib_dir/busybox_unstripped"
262     try $CC $CFLAGS $LDFLAGS \
263             -o $EXE \
264             $SORT_COMMON \
265             $SORT_SECTION \
266             $GC_SECTIONS \
267             $START_GROUP $O_FILES $END_GROUP \
268             -L"$sharedlib_dir" -lbusybox \
269             $l_list \
270             $INFO_OPTS \
271     || {
272         echo "Linking $EXE failed"
273         cat $EXE.out
274         exit 1
275     }
276     $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
277     echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
278 fi
279
280 if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
281     echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
282     gcc -DNAME_MAIN -E -include include/autoconf.h include/applets.h \
283     | grep -v "^#" \
284     | grep -v "^$" \
285     > applet_lst.tmp
286     while read name main junk; do
287
288         echo "\
289 void lbb_prepare(const char *applet, char **argv);
290 int $main(int argc, char **argv);
291
292 int main(int argc, char **argv)
293 {
294         lbb_prepare(\"$name\", argv);
295         return $main(argc, argv);
296 }
297 " >"$sharedlib_dir/applet.c"
298
299         EXE="$sharedlib_dir/$name"
300         try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
301                 -o $EXE \
302                 $SORT_COMMON \
303                 $SORT_SECTION \
304                 $GC_SECTIONS \
305                 -L"$sharedlib_dir" -lbusybox \
306                 -Wl,--warn-common \
307         || {
308             echo "Linking $EXE failed"
309             cat $EXE.out
310             exit 1
311         }
312         rm -- "$sharedlib_dir/applet.c" $EXE.out
313         $STRIP -s --remove-section=.note --remove-section=.comment $EXE
314         # Let user see that we do something - list the names of created binaries:
315         echo "$EXE"
316
317     done <applet_lst.tmp
318 fi
319
320 # libbusybox.so is needed only for -lbusybox at link time,
321 # it is not needed at runtime. Deleting to reduce confusion.
322 rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
323 exit 0 # or else we may confuse make